#include "crapmenu.h"

void CrapMenu::Go()
{
	int selection = 0;
	Assert(mNumItems > 0 && "no items in menu");
	for (;;)
	{
		int x = 10; 
		int y = 10;
		mGfx.Fill(0);
		for (int i = 0; i < mNumItems; ++i)
		{
			int end = x;
			if (mItems[i].type == IntSlider)
			{
				end = mGfx.DrawStringf(x, y, mItems[i].prompt, *(int *)mItems[i].value);
			}
			else if (mItems[i].type == BoolToggle)
			{
				end = mGfx.DrawStringf(x, y, mItems[i].prompt, (*(bool *)mItems[i].value) ? "true" : "false");
			}
			if (i == selection)
			{
				mGfx.DrawRect(x - 2, y - 2, end + 1, y + 14, 0xffff);
			}
			y += 18;
		}
		if (mPrompt) mGfx.DrawString(x, y, mPrompt);
		mGfx.Flip();
		switch (mPad.WaitForOneOf(PAD_UP | PAD_DOWN | PAD_LEFT | PAD_RIGHT | PAD_START))
		{
			case PAD_UP:
				--selection;
				if (selection < 0) selection = 0;
				mSound.Play(mUpDown);
				break;
			case PAD_DOWN:
				++selection;
				if (selection >= mNumItems) selection = mNumItems - 1;
				mSound.Play(mUpDown);
				break;
			case PAD_LEFT:
				if (mItems[selection].type == IntSlider)
				{
					(*((int *)mItems[selection].value))--;
					if ((*((int *)mItems[selection].value)) < 0) *((int *)mItems[selection].value) = 0;
				}
				else if (mItems[selection].type == BoolToggle)
				{
					(*(bool *)mItems[selection].value) = !(*(bool *)mItems[selection].value);
				}
				// gah, this oldskool c crap is pretty nasty. would be nice to make this not terrible if new or virtual worked
				if (mItems[selection].callback) mItems[selection].callback(mItems, mNumItems, selection);
				mSound.Play(mChange);
				break;
			case PAD_RIGHT:
				if (mItems[selection].type == IntSlider)
				{
					(*((int *)mItems[selection].value))++;
					if ((*((int *)mItems[selection].value)) >= (*((int *)mItems[selection].aux))) *((int *)mItems[selection].value) = (*((int *)mItems[selection].aux)) - 1;
				}
				else if (mItems[selection].type == BoolToggle)
				{
					(*(bool *)mItems[selection].value) = !(*(bool *)mItems[selection].value);
				}
				// ditto
				if (mItems[selection].callback) mItems[selection].callback(mItems, mNumItems, selection);
				mSound.Play(mChange);
				break;
			case PAD_START:
				if (!mConfirmExit || mConfirmExit(mItems, mNumItems)) return;
		}
	}
}

void CrapMenu::Add(const CrapMenuItem& item)
{
	Assert(mNumItems < ARRAYSIZE(mItems));
	mItems[mNumItems++] = item;
}
