#ifndef INCLUDED_crappad_H
#define INCLUDED_crappad_H

#include "base.h"

#define PAD_SELECT		0x0001 
#define PAD_START		0x0008 
#define PAD_UP			0x0010 
#define PAD_RIGHT		0x0020 
#define PAD_DOWN		0x0040 
#define PAD_LEFT		0x0080 
#define PAD_LTRIGGER	0x0100 
#define PAD_RTRIGGER	0x0200 
#define PAD_TRIANGLE	0x1000 
#define PAD_CIRCLE		0x2000 
#define PAD_CROSS		0x4000 
#define PAD_SQUARE		0x8000 

class CrapPad : public NonCopyable
{
	public:
		CrapPad();
		~CrapPad();

		unsigned long Read(bool doRepeat = true);
		unsigned long WaitForOneOf(int mask, bool doRepeat = true);

	private:
		unsigned long mBeforeTick;
		unsigned long mBeforeInput;
};

#endif
