#include "crapsound.h"
#include "base.h"

#ifdef PIXELTOASTER

#include <windows.h>
#include <stdio.h>

CrapSound::CrapSound() {}
CrapSound::~CrapSound() {}
void CrapSound::Play(const CrapSoundSample& sample)
{
	char msg[256];
	sprintf(msg, "Playing sound at %p (%d)\n", sample.data, sample.length);
	OutputDebugString(msg);
}

#else

extern "C"
{
	long sceAudioOutputPannedBlocking(long, long, long, void *);//
	long sceAudioChReserve(long, long samplecount, long);//init buffer? returns handle, minus if error
	void sceAudioChRelease(long handle);//free buffer?
}

CrapSound::CrapSound()
{
}
CrapSound::~CrapSound()
{
}

void CrapSound::Play(const CrapSoundSample& sample)
{
#ifdef DO_AUDIO
	short buf[256*4];
	long handle = sceAudioChReserve(-1, 256, 0);
	Assert(handle >= 0);
	long len = (int)(sample.length / 256) * 256 / sizeof(short);
	for (int i = 0; i < len; i += 256/4)
	{
		short* p = buf;
		for (int j = 0; j < 256; ++j)
		{
			*p++ = (short)(((short *)sample.data)[i + j/4]);
		}
		sceAudioOutputPannedBlocking(handle, 0x6000, 0x6000, (void*)buf);
	}
	sceAudioChRelease(handle);
#endif
}

#endif
