# dumps out image as zipped raw 1555

use strict;
use warnings;
use GD;
use Data::Dumper;
use Compress::Zlib;

my $image = GD::Image->new($ARGV[0]);

my $rawdata;

my $h = $image->height();
my $w = $image->width();

for (my $y = 0; $y < $h; $y++)
{
	for (my $x = 0; $x < $w; $x++)
	{
		my ($r, $g, $b) = $image->rgb($image->getPixel($x, $y));
		my $colour = 0x8000 | (($b >> 3) << 10) | (($g >> 3) << 5) | ($r >> 3);
		$rawdata .= pack('S', $colour);
	}
}

my $temp1 = compress($rawdata);
my $compressedData = substr($temp1, 2, -4);

open OUT, ">$ARGV[1]" or die "couldn't open output";

my @compressed = unpack('C*', $compressedData);
my $outname = $ARGV[0];
$outname =~ s/\..*$//;
$outname =~ s/.*\\//;
print OUT "// dumped from $ARGV[0].\n";
print OUT "// in 1555 little endian (suitable to blit to psp vram).\n";
print OUT "// compressed with zlib.\n\n";
print OUT "const unsigned int Width_${outname} = $w;\n";
print OUT "const unsigned int Height_${outname} = $h;\n";
print OUT "const unsigned char CompressedData_${outname}[] = { ";
foreach my $c (@compressed)
{
	print OUT "$c, ";
}
print OUT "};\n";


