use strict;
use GD;
use GD::Text::Wrap;
use Unicode::Transform qw(:all);
use Compress::Zlib;
use Encode qw/decode/;
use Encode::CN;
use Data::Dumper;
use Spreadsheet::ParseExcel::Simple;



#print Dumper(Encode->encodings());
my %usedGlyphs;

sub tohex($)
{
	my $enc = shift;
	my $final = "{ ";
	die "not even" if length($enc) % 2 != 0;
	#print Dumper($enc);
	for (my $i = 0; $i < length($enc); $i += 2)
	{
		$final .= sprintf("aGlyph_%02X%02X, ", ord(substr($enc, $i, 1)), ord(substr($enc, $i + 1, 1)));
		$usedGlyphs{sprintf("%02X%02X", ord(substr($enc, $i, 1)), ord(substr($enc, $i + 1, 1)))} = 1;
	}
	$final .= "}";
	$final;
}

my $outorder = "order.inc";

my $xls = Spreadsheet::ParseExcel::Simple->read('words.xls');
#print Dumper($xls);

#my $file = 'words.txt';
#open IN, "<:encoding(utf8)", "$file" or die "couldn't open $file";
open OUT2, ">$outorder" or die "couldn't open $outorder";
#binmode IN;
my $count = 0;
my $mode;
my @pinyinAndEnglish;
#while (<IN>)
foreach my $worksheet (@{$xls->{book}{Worksheet}})
{
	foreach my $row (@{$worksheet->{Cells}})
	{
		die "was expecting first column to be ucs2" if $row->[0]{Code} ne 'ucs2';
		die "was expecting second column to be latin1 (undef)" if defined $row->[1]{Code};
		die "was expecting third column to be latin1 (undef)" if defined $row->[2]{Code};
		my @cols = ($row->[0]{Val}, $row->[1]{Val}, $row->[2]{Val});
		print OUT2 "static const unsigned char * const word${count}[] = " . tohex($cols[0]) . ";\n";
		push @pinyinAndEnglish, [ $cols[1], $cols[2] ];
		++$count;
		print "$count\n";
	}
}
#close IN;

#print Dumper(\%usedGlyphs);

sub lameunesc($)
{
	my $eng = shift;
	$eng =~ s/\\\&#34;/\\"/g;
	$eng =~ s/\\\&#39;/'/g;
	$eng;
}

print OUT2 "typedef struct EntryData { const char * const pinyin; const char * const english; const unsigned char * const * const glyph; const unsigned short numglyphs; } EntryData;\n";

print OUT2 "const EntryData aEntries[] = {\n";
for (my $i = 0; $i < $count; $i++)
{
	#print "$i\n";
	print OUT2 ('{ "' . $pinyinAndEnglish[$i]->[0] . '", "' . lameunesc($pinyinAndEnglish[$i]->[1]) . '", word' . $i . ", (unsigned short)(sizeof(word$i)/sizeof(word${i}[0])) },\n");
}
print OUT2 "};\n";

close OUT2;




my $output = "glyphs.inc";
open OUT, ">$output" or die "couldn't open $output";
foreach my $glyph (keys %usedGlyphs)
{
	my $gd = GD::Image->new(64,64);
	my $white = $gd->colorAllocate(255,255,255);
	my $black = $gd->colorAllocate(  0,  0,  0);

	print "$glyph\n";
	my $firstByte = substr($glyph, 0, 2);
	my $secondByte = substr($glyph, 2, 2);
	#print "$firstByte\n";
	#print "$secondByte\n";
	my $first = hex $firstByte;
	my $second = hex $secondByte;

	my $wp = GD::Text::Wrap->new($gd,
	width       => 64,
	color       => $white,
	text        => utf16be_to_utf8(pack("C*", $first, $second))
	);
	$gd->filledRectangle(0,0,64,64,$black);
	$wp->set(align => 'center');
	$wp->set_font('c:\windows\fonts\simsun.ttc',44);
	$wp->draw(0,0);

=pod
	open TEST, ">test.png" or die;
	binmode TEST;
	print TEST $gd->png();
	close TEST;
=cut

	my $rawdata;
	for (my $y = 0; $y < 64; $y++)
	{
		for (my $x = 0; $x < 64; $x++)
		{
			my ($r,$g,$b) = $gd->rgb($gd->getPixel($x, $y));
			die "not monochrome" if ($r != $g || $r != $b);
			$rawdata .= pack('C', $r);
		}
	}
	my $temp1 = compress($rawdata);
	my $compressedData = substr($temp1, 2, -4);

=pod
	open TEST, ">out.raw" or die;
	binmode TEST;
	print TEST $compressedData;
	close TEST;
=cut

	my @compressed = unpack('C*', $compressedData);
	print OUT "const unsigned char aGlyph_${glyph}[] = { ";
	foreach my $c (@compressed)
	{
		print OUT "$c, ";
	}
	print OUT "};\n";
}

print OUT "#include \"order.inc\"\n";

close OUT;

